
\chapter{Conclusion}
\label{sec:conclusion}
{

This thesis presents a space-time multi-level $hp$-method to approximate the nonlinear heat equation for simulating the temperature evolution in \gls*{LPBF} processes. Local refinements in four dimensions are possible by using \review{a} multi-level $hp$-\review{framework} to construct data-oriented algorithms and data structures that extend to any number of dimensions. The introduction of tensor-product masks and location matrices with corresponding pair-wise operations on their array slices provides the foundation for efficient implementations. In particular, a small memory management overhead and favorable memory access patterns distinguish this approach from the original object-oriented formulation already in one, two, and three dimensions. While the simplicity of the presented alternative reduces the effort to construct and maintain the $hp$-finite element data structures, modifying the mesh topology invalidates basis data that was computed on the previous mesh state. However, applications with evolving meshes often benefit from creating an entirely new mesh and basis rather than modifying the existing ones\review{, which} results in cleaner implementations and can simplify applications that require both the new and the old discretization, such as certain time-stepping schemes or error estimators.

The combination of this multi-level $hp$ extension with a continuous Galerkin-Petrov formulation of the nonlinear heat equation leads to a finite element method that discretizes space and time together in a four-dimensional setting. Testing with the time derivative of the trial functions results in optimal convergence and allows splitting the solution into consecutive time slabs, which is crucial for maintaining manageable problem sizes. 
By meshing \review{one} time slab \review{ahead}, the multi-level $hp$-basis functions are compatible across the slab interface in time by construction. The refinement of the time slab meshes starts at the current position of the laser with the maximum refinement depth. It gradually reduces towards positions further in the past while simultaneously increasing the refinement width. The thermal model uses a volumetric source that extends the two-dimensional laser intensity profile into the material by a Gaussian function in the $z$-direction. The length of this extension \review{allows} tuning the width and depth of the resulting melt pool shape to the \review{experiments}. Moreover, the latent heat of fusion is \review{modeled} as a spike in the heat capacity. \review{Different regularization shapes} of \review{the phase transition} primarily influence the cooling rates and the length of the simulated melt pool.

In the first preliminary verification benchmark, the convergence of the multi-level $hp$ extension is analyzed using a manufactured solution to Poisson's equation with a point singularity. When increasing the refinement depth and the polynomial degree, the energy error reduces exponentially while maintaining a polynomial runtime and memory scaling. These results agree with the theoretical estimates and are essential for obtaining good performance in real-world applications. Then, the space-time formulation is validated against the experimental results published for the AMB2018-02 benchmark. The dimensions of the simulated melt pool shape coincide with the measurements after tuning the absorptivity, the depth extension of the laser source, and the shape of the phase change regularization. Shifting the latent heat capacity spike towards higher temperatures reduces the influence on the temperatures after the solidification. A significant difference in the cooling rates after solidification may result from measurement inaccuracies and requires further investigation. The potential for computing longer and more complicated paths is demonstrated using the setup of the AMB2018-02 benchmark to hatch an area of one square centimeter with diagonal strokes. The ad hoc refinement captures the solution characteristic well, and the resulting temperature field provides insight into problematic regions with larger than intended melt pools. Finally, the runtime of the space-time approach is compared to an equivalent second-order time-stepping method. This study starts with a small domain that is gradually extended by adding base elements on the boundary. This increase in peripheral cost impacts the space-time approach less because the base mesh of one time slab uses only a single element in time for a relatively long duration. The speedup over the equivalent time-stepping can reach factors of ten or even over one hundred when using a direct solver for both approaches. A major current limitation of the presented space-time method is the unsymmetric linear system and the need to use a direct solver.

This thesis shows that finite element discretizations with local refinement in space-time can bridge the scales present in the simulation of \gls*{LPBF} processes. Such proof of concept is a crucial first step, but several challenges must be addressed before the presented approach can be used in practice. Longer simulations require including boundary conditions that account for the heat loss due to radiation and convection. The simulation of an actual powder bed must also consider the reduced conductivity of metal powder compared to melted and solidified metal. This history dependency may pose additional challenges in combination with a space-time discretization. Then, the speedup compared to time-stepping methods may be significant in some situations, but it is insufficient to enable part-scale simulations. Massively parallel implementations are necessary to efficiently use enough \gls*{HPC} resources and reduce the computational time to a practical amount. The extensions of the multi-level $hp$ data structures and the development of a scalable iterative solver are crucial for the success of the method. Alternative to investigating linear solvers for the presented Petrov-Galerkin method, exploring \review{different} space-time methods that are more suitable for parallel extensions may be necessary. A potential application for such an efficient and scalable thermal solver for \gls*{LPBF} processes may be optimizing the laser power along a given laser path. \review{Automatically c}reating a time-\review{discrete} laser power that minimizes constraints like a constant melt pool volume with minimal deviations from the \gls*{CAD} model may help improve and automate the 3D printing workflow. Finally, automatic adaptive methods can capture complicated solution characteristics of real applications more efficiently and robustly than the presented ad hoc refinement based on the laser path history. 

}